import numpy as np
import matplotlib.pyplot as plt
from sklearn.model_selection import train_test_split
from sklearn.tree import DecisionTreeClassifier

A = np.genfromtxt( "lunas.csv", delimiter=',', dtype=float )

X = A[:,0:2]
y = A[:,2]
print( X.shape )
print( y.shape )

X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X, y, random_state = 40 )

arbol = DecisionTreeClassifier( max_depth=5, random_state=0 )
arbol.fit( X_entrena, y_entrena )

vv = np.zeros( (1,2) )

fig, ax = plt.subplots()
ax.set_aspect( 1 )

# Create grid values first.
n = 100
xi = np.linspace(-1.3, 2.3, n)
yi = np.linspace(-0.8, 1.2, n)
vx, vy = np.meshgrid( xi, yi )

zi = np.zeros( (n,n) )
i = 0
while i < n :
	vv[0,1] = yi[i]
	j = 0
	while j < n :
		vv[0,0] = xi[j]
		zi[i,j] = arbol.predict( vv ) 
		j += 1
	i += 1

# Linearly interpolate the data (x, y) on a grid defined by (xi, yi).

ax.set_xlim( (-1.3, 2.3) )
ax.set_ylim( (-0.8, 1.2) )

# Para poner la escala del color:
# cntr = ax.contourf(vx, vy, zi )
# fig.colorbar(cntr, ax=ax)
ax.contourf(vx, vy, zi )

# Los puntos
ax.scatter( X[:,0], X[:,1], c=y )

plt.show( )
