from sklearn.datasets import load_breast_cancer
from sklearn.model_selection import train_test_split
from sklearn.tree import DecisionTreeClassifier
from sklearn.tree import export_graphviz

cancer = load_breast_cancer( )

X_entrena, X_prueba, y_entrena, y_prueba = train_test_split(
   cancer.data, cancer.target, stratify=cancer.target, random_state = 42 )

arbol = DecisionTreeClassifier( max_depth=4, random_state=0 )

arbol.fit( X_entrena, y_entrena )

print( "Precisiones" )
print( "En el entrenamiento:", arbol.score( X_entrena, y_entrena ) ) 
print( "En la prueba       :", arbol.score( X_prueba, y_prueba ) )

export_graphviz( arbol, out_file="arbol.dot",
                 class_names=["maligno", "benigno"], 
                 feature_names=cancer.feature_names,
                 impurity=False, filled=True )
